From d39c17cf129435a052e2496754b41ce75eb1d78b Mon Sep 17 00:00:00 2001
From: Vinay Gannevaram <quic_vganneva@quicinc.com>
Date: Fri, 9 Aug 2024 16:26:55 +0530
Subject: [PATCH 07/16] sigma-dut: Add support to restrict CSA on DFS P2P GO

Add support to restrict CSA on P2P GO device operating in DFS channel.

Change-Id: I71be35090b0b683c4002cbce90935eb56f6a5694
Signed-off-by: Shivani Baranwal <quic_shivbara@quicinc.com>
---
 sta.c | 55 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 55 insertions(+)

diff --git a/sta.c b/sta.c
index eb9e923..4ad7ddc 100644
--- a/sta.c
+++ b/sta.c
@@ -17039,6 +17039,16 @@ wcn_sta_set_rfeature_he(const char *intf, struct sigma_dut *dut,
 	char *token = NULL, *result;
 	char buf[60];
 	u16 tx_rate = 0;
+	int ifindex;
+	const char *ifname;
+
+	ifindex = if_nametoindex(intf);
+	if (ifindex == 0) {
+		sigma_dut_print(dut, DUT_MSG_ERROR,
+				"%s: Index for interface %s failed",
+				__func__, intf);
+		return -1;
+	}
 
 	val = get_param(cmd, "nss_mcs_opt");
 	if (val) {
@@ -17467,6 +17477,51 @@ wcn_sta_set_rfeature_he(const char *intf, struct sigma_dut *dut,
 				  epcs_function);
 	}
 
+	val = get_param(cmd, "EvacCurrChan");
+	if (val && atoi(val) == 0) {
+		if (dut->program == PROGRAM_P2P) {
+			sigma_dut_print(dut, DUT_MSG_ERROR, "P2P program");
+			ifname = get_group_ifname(dut, intf);
+			ifindex = if_nametoindex(ifname);
+		}
+#ifdef NL80211_SUPPORT
+		int ret;
+		struct nl_msg *msg;
+		struct nlattr *params;
+
+		msg = nl80211_drv_msg(dut, dut->nl_ctx, ifindex, 0,
+				      NL80211_CMD_VENDOR);
+		if (!msg ||
+		    nla_put_u32(msg, NL80211_ATTR_IFINDEX, ifindex) ||
+		    nla_put_u32(msg, NL80211_ATTR_VENDOR_ID, OUI_QCA) ||
+		    nla_put_u32(msg, NL80211_ATTR_VENDOR_SUBCMD,
+				QCA_NL80211_VENDOR_SUBCMD_WIFI_TEST_CONFIGURATION)) {
+			nlmsg_free(msg);
+			return ERROR_SEND_STATUS;
+		}
+
+		params = nla_nest_start(msg, NL80211_ATTR_VENDOR_DATA);
+		if (!params ||
+		    nla_put_u8(msg,
+			       QCA_WLAN_VENDOR_ATTR_WIFI_TEST_CONFIG_DISABLE_CHAN_SWITCH_INITIATION, 1)) {
+			nlmsg_free(msg);
+			return ERROR_SEND_STATUS;
+		}
+		nla_nest_end(msg, params);
+
+		ret = send_and_recv_msgs(dut, dut->nl_ctx, msg, NULL, NULL);
+		if (ret) {
+			sigma_dut_print(dut, DUT_MSG_ERROR,
+					"%s: err in send_and_recv_msgs, ret=%d",
+					__func__, ret);
+			return ERROR_SEND_STATUS;
+		}
+#else /* NL80211_SUPPORT */
+		sigma_dut_print(dut, DUT_MSG_ERROR,
+				"Disable chan switch initiation can't be set without NL80211_SUPPORT defined");
+		return -1;
+#endif /* NL80211_SUPPORT */
+	}
 	return SUCCESS_SEND_STATUS;
 
 failed:
-- 
2.34.1

